/*---------------------------------------------------------------------------
 * Copyright (C) 2008-2009 - Emanuele Bovisio
 *
 * This file is part of Mulk.
 *
 * Mulk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Mulk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Mulk.  If not, see <http://www.gnu.org/licenses/>.
 *---------------------------------------------------------------------------*/

#ifndef _DEFINES_H_
#define _DEFINES_H_

#if HAVE_CONFIG_H
#include "config.h"
#endif
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <curl/curl.h>
#include <curl/multi.h>
#include "uri_parser.h"

/* log levels */
#define MERR 0
#define MWAR 1
#define MNOTE 2
#define MINFO 3

#define MAX_LINE_LENGTH 1000

extern char version_number[];

typedef struct option_value_t {
	int quiet;
	int verbosity;
	int depth;
	char *option_filename;
	char *url_filename;
#ifdef ENABLE_METALINK
	char *metalink_filename;
	char *metalink_location;
	char *metalink_os;
#endif
	char *report_filename;
	char *report_csv_filename;
	int max_sim_conns_per_host;
	int max_sim_conns;
	int disable_save_tree;
	int save_gif_image;
	int save_png_image;
	int save_jpeg_image;
	int min_image_width;
	int max_image_width;
	int min_image_height;
	int max_image_height;
	char *output_directory;
} option_value_t;

extern option_value_t option_values;

int set_option(char *option, char *value, int remove_minus, int *value_used);

int is_printf(int log_level);

#endif /* not _DEFINES_H_ */
